<template>
    <v-row class="mb-2">
        <v-col cols="8">
            <p class="text-start text-h1 text-md-h3 text-lg-h2 ">Users Table</p>
        </v-col>
        <v-col cols="4">

            <v-row class="d-flex justify-end">
                <!-- dialog create users -->
                <v-dialog v-model="dialogCreate" persistent width="600px">
                    <template v-slot:activator="{ props }">
                        <v-btn color="primary" v-bind="props" class="text-h2">
                            +
                        </v-btn>
                    </template>
                    <v-card>
                        <v-card-title class="ml-8 mt-6">
                            <span class="text-h4">Craeate User</span>
                        </v-card-title>
                        <v-card-text>
                            <v-container>
                                <v-form v-model="form" @submit.prevent="onSubmit">

                                    <v-row>
                                        <v-col cols="6" class="pa-2">
                                            <v-text-field v-model="fname" label="First name*" :rules="[rules.required]"
                                                clearable required></v-text-field>
                                        </v-col>
                                        <v-col cols="6" class="pa-2">
                                            <v-text-field v-model="lname" label="Last name*" :rules="[rules.required]"
                                                clearable required></v-text-field>
                                        </v-col>
                                        <v-col cols="12" class="pa-2">
                                            <v-text-field v-model="username" label="Username*" :rules="[rules.required]"
                                                clearable required></v-text-field>
                                        </v-col>
                                        <v-col cols="12" class="pa-2">
                                            <v-text-field v-model="password" label="Password" style="min-height: 96px"
                                                :rules="[rules.required]" clearable type="password"></v-text-field>
                                        </v-col>
                                        <v-col cols="12" class="pa-2">
                                            <v-text-field v-model="email" label="email*" type="email"
                                                :rules="[rules.required]" clearable required></v-text-field>
                                        </v-col>
                                        <v-col cols="12" class="pa-2">
                                            <v-text-field v-model="avatar" label="Avatar"></v-text-field>
                                        </v-col>
                                    </v-row>
                                </v-form>
                            </v-container>
                        </v-card-text>
                        <v-card-actions class="mb-6 mr-8">
                            <v-spacer></v-spacer>
                            <v-btn variant="tonal" @click="dialogCreate = false">
                                Close
                            </v-btn>
                            <v-btn :disabled="!form" variant="elevated" type="submit" class="bg-success"
                                @click="dialogCreate = createUser()">
                                Save
                            </v-btn>
                        </v-card-actions>
                    </v-card>
                </v-dialog>
            </v-row>
        </v-col>
    </v-row>

    <!-- Users table -->
    <v-table fixed-header height="572px" class="trowsColor">
        <thead>
            <tr>
                <th class="text-center">
                    <p>ID</p>
                </th>
                <th class="text-center">
                    <p>Avatar</p>
                </th>
                <th class="text-start">
                    <p>First name</p>
                </th>
                <th class="text-start">
                    <p>Last name</p>
                </th>
                <th class="text-start">
                    <p>User name</p>
                </th>
                <th class="text-center">
                    <p>Update</p>
                </th>
            </tr>
        </thead>
        <tbody>
            <tr v-for="item in rows" :key="item.id" style="cursor: pointer;">
                <td class="text-center">{{ item.id }}</td>
                <td class="d-flex jutify-center"><v-img :width="50" aspect-ratio="4/3" :src=item.avatar></v-img></td>
                <td class="text-start">{{ item.fname }}</td>
                <td class="text-start">{{ item.lname }}</td>
                <td class="text-start">{{ item.username }}</td>
                <td>
                    <div class="d-flex flex-row justify-space-evenly">
                        <v-btn @click="updateUserDialog(item)">EDIT</v-btn>
                        <v-btn @click="deleteUser(item.id), delAlert = true" class="bg-error">DELETE </v-btn>

                        <!-- DialogDelete -->
                        <!-- <v-dialog v-model="dialog2" width="auto" >
        <v-card>
            <v-card-title class="bg-info">
               Delete
            </v-card-title>
            <v-card-text>
                 <p class="font-weight-black ml-4">
                    Are you sure to delete
                    <span class="mr-4">{{ item.id }} {{ item.fname }} {{ item.lname }}</span> 
                    ?
                </p>
            </v-card-text>
            <v-card-actions>
               
                <v-btn color="primary" variant="text" @click="dialog2 = false">
                    Close
                </v-btn>
            </v-card-actions>
        </v-card>
    </v-dialog> -->

                    </div>
                </td>
            </tr>
        </tbody>
    </v-table>


    <!-- dialog update user -->
    <v-dialog v-model="dialogEdit" width="600">
        <v-card v-if="selectedRow.id" class="pa-4">
            <v-card-title class="bg-info">
                <p class="font-weight-black ml-4">
                    <span class="mr-4">{{ selectedRow.id }}</span> {{ selectedRow.fname }} {{ selectedRow.lname }}

                </p>
            </v-card-title>
            <v-card-text class="text-h6">
                <v-form v-model="form" @submit.prevent="onSubmit">
                    <v-row no-gutters>
                        <v-row>

                            <v-col cols="4"><v-img :width="120" aspect-ratio="16/9" :src=selectedRow.avatar></v-img></v-col>
                            <v-col cols="8">

                                <v-row>
                                    <v-text-field v-model="selectedRow.fname" label="First name" :rules="[rules.required]"
                                        clearable required />
                                </v-row>
                                <v-row>
                                    <v-text-field v-model="selectedRow.lname" label="Last name" :rules="[rules.required]"
                                        clearable required />
                                </v-row></v-col>

                        </v-row>

                        <v-col cols="12">
                            <v-text-field v-model="selectedRow.username" label="User Name" :rules="[rules.required]"
                                clearable required></v-text-field>
                        </v-col>
                        <v-col cols="12">
                            <v-text-field v-model="selectedRow.email" type="email" label="Email" :rules="[rules.required]"
                                clearable required></v-text-field>
                        </v-col>
                        <v-col cols="12">
                            <v-text-field v-model="selectedRow.avatar" label="Avatar"></v-text-field>
                        </v-col>
                    </v-row>
                </v-form>
            </v-card-text>

            <v-card-actions class="d-flex justify-end">
                <v-btn variant="tonal" text @click="dialogEdit = false">Close</v-btn>
                <v-btn class="bg-success" :disabled="!form" text @click="updateUser">Save</v-btn>
            </v-card-actions>
        </v-card>
    </v-dialog>
</template>
  
<script >
const runtimeConfig = useRuntimeConfig();
const apiUrl = runtimeConfig.public.URL_Auth;
   
definePageMeta({
    middleware: "auth-khan"
    
  })

export default {

    data() {
        return {
            rows: [],
            dialogEdit: false,
            dialogCreate: false,
            selectedRow: {},
            delAlert: false,
            form: false,
            fname: '',
            lname: '',
            username: '',
            password: '',
            email: '',
            avatar: '',
            rules: {
                required: value => !!value || 'Field is required',
            },
        };


    },

    // rules: {
    //     email: v => !!(v || '').match(/@/) || 'Please enter a valid email',
    //     length: len => v => (v || '').length >= len || `Invalid character length, required ${len}`,
    //     password: v => !!(v || '').match(/^(?=.*[a-z])(?=.*[A-Z])(?=.*\d)(?=.*(_|[^\w])).+$/) ||
    //         'Password must contain an upper case letter, a numeric character, and a special character',
    //     required: v => !!v || 'This field is required',
    // },

    mounted() {
        this.fetchData();
    },
    methods: {
        onSubmit() {
            if (!this.form) return

        },
        required(v) {
            return !!v || 'Field is required'
        },

        async fetchData() {
            try {

                const response = await fetch(`${apiUrl}/api/users`);
                if (!response.ok) {
                    throw new Error('Network response was not ok.');
                }
                const data = await response.json();
                this.rows = data;
                console.log('Fetched data:', data);
            } catch (error) {
                console.error('Error fetching data:', error);
            }
        },
        // dialog for update User
        updateUserDialog(item) {
            this.selectedRow = { ...item };
            this.dialogEdit = true;

        },
        // methods delete user 
        async deleteUser(userId) {
            try {
                const response = await fetch(`${apiUrl}/api/users/delete`, {
                    method: 'DELETE',
                    headers: {
                        'Content-Type': 'application/json',
                    },
                    body: JSON.stringify({ id: userId }),
                });

                if (!response.ok) {
                    throw new Error('Network response was not ok');
                }

                const data = await response.json();
                console.log('User deleted success', data);
                console.info("deleted User Id:", data);
                await this.fetchData();
            } catch (error) {
                console.error('There was a problem delete user', error);
            }
        },
        // methods update user 
        async updateUser() {
            const updatedUserData = {
                id: this.selectedRow.id,
                fname: this.selectedRow.fname,
                lname: this.selectedRow.lname,
                username: this.selectedRow.username,
                email: this.selectedRow.email,
                avatar: this.selectedRow.avatar,

            };

            try {
                const response = await fetch(`${apiUrl}/api/users/update`, {
                    method: 'PUT',
                    headers: {
                        'Content-Type': 'application/json',
                    },
                    body: JSON.stringify(updatedUserData),
                });
                if (!response.ok) {
                    throw new Error('Network response was not ok');
                }

                const data = await response.json();
                console.log('User updated success', data);
                this.dialogEdit = false;
                await this.fetchData();
            } catch (error) {
                console.error('There was a problem update user', error);
            }
        },
        // methods create user
        async createUser() {
            const userData = {
                fname: this.fname,
                lname: this.lname,
                username: this.username,
                password: this.password,
                email: this.email,
                avatar: this.avatar,
            };
            try {
                const response = await fetch(`${apiUrl}/api/users/create`, {
                    method: 'POST',
                    headers: {
                        'Content-Type': 'application/json',
                    },
                    body: JSON.stringify(userData),
                });
                if (!response.ok) {
                    throw new Error('Network response was not ok');
                }

                const data = await response.json();
                console.log('Create User success', data);
                this.fname = '';
                this.lname = '';
                this.username = '';
                this.password = '';
                this.email = '';
                this.avatar = '';
                this.dialogCreate = false;
                await this.fetchData();
            } catch (error) {
                console.error('There was a problem create user', error);
            }
        },
    },

};

</script>
<style scoped>
* {
    margin: 0;
    padding: 0;
    box-sizing: border-box;
}

.trowsColor {
    background-color: #E1F5FE;
}

tbody tr:hover {
    background-color: #bbdefb;
}
</style>